## fatsort 1.6.4.625

=== man/Makefile ===
HELP2MAN=help2man

all: fatsort.1

fatsort.1: ../src/fatsort
	${HELP2MAN} --name "FAT sorting tool" ../src/fatsort -o fatsort.1 -N

clean:
	rm -f fatsort.1

.PHONY: clean

=== src/Makefile ===
CC=gcc
LD=gcc

ifdef DEBUG
CFLAGS += -g -DDEBUG=$(DEBUG) -fstack-protector-all
DEBUG_OBJ=mallocv.o
else
LDFLAGS += -s
endif

CFLAGS += -Wall -Wextra
override CFLAGS+= -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE64_SOURCE

INSTALL_FLAGS=-m 0755 -p -D

UNAME_S := $(shell uname -s)
UNAME_P := $(shell uname -p)
UNAME_O := $(shell uname -o)

EXECUTABLE:=fatsort

ifeq ($(UNAME_O),Cygwin)
	_CYGWIN=1
endif

ifeq ($(OS),Windows_NT)
	ifndef _CYGWIN
		override CCFLAGS += -D __WIN32__ -mno-ms-bitfields
	else
		override CFLAGS += -D __CYGWIN__
		override CFLAGS += -D __LINUX__
		override LDFLAGS += -liconv
		SBINDIR=/usr/local/sbin
	endif
else
	ifdef MINGW
		CC=i686-w64-mingw32-gcc
		#LD=i686-w64-mingw32-gcc
		EXECUTABLE:=${EXECUTABLE}.exe
		override LDFLAGS += -liconv -static
		override CFLAGS += -D __WIN32__ -D __MINGW__
	else

		ifeq ($(UNAME_S),Linux)
			override CFLAGS += -D __LINUX__
		endif
		ifeq ($(UNAME_S),FreeBSD)
			override CFLAGS += -D __BSD__
		endif
		ifeq ($(UNAME_S),OpenBSD)
			override CFLAGS += -D __BSD__
		endif
		ifeq ($(UNAME_S),NetBSD)
			override CFLAGS += -D __BSD__
		endif
		ifeq ($(UNAME_S),Darwin)
			# Detect Mac OS X ($OSTYPE = darwin9.0 for Mac OS X 10.5 and darwin10.0 for Mac OS X 10.6)
			override CFLAGS += -D __OSX__
			override LDFLAGS += -liconv
			# OS X's install does not support the '-D' flag.
			INSTALL_FLAGS=-m 0755 -p
			# Mac OS X does not have a "/usr/local/sbin"
			SBINDIR=/usr/local/bin
		else
			SBINDIR=/usr/local/sbin
		endif
	endif
endif

OBJ=fatsort.o FAT_fs.o deviceio.o endianness.o sig.o entrylist.o errors.o options.o clusterchain.o sort.o misc.o natstrcmp.o stringlist.o regexlist.o

all: ${EXECUTABLE}

${EXECUTABLE}: $(OBJ) $(DEBUG_OBJ) Makefile
	${CC} $(OBJ) $(DEBUG_OBJ) -o $@ ${LDFLAGS}

fatsort.o: fatsort.c endianness.h sig.h FAT_fs.h  options.h \
 stringlist.h errors.h sort.h clusterchain.h misc.h mallocv.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

FAT_fs.o: FAT_fs.c FAT_fs.h  errors.h endianness.h deviceio.h \
 mallocv.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

endianness.o: endianness.c endianness.h mallocv.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

sig.o: sig.c sig.h mallocv.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

entrylist.o: entrylist.c entrylist.h FAT_fs.h  options.h \
 stringlist.h errors.h natstrcmp.h mallocv.h endianness.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

errors.o: errors.c errors.h mallocv.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

options.o: options.c options.h  FAT_fs.h stringlist.h regexlist.h errors.h \
 mallocv.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

clusterchain.o: clusterchain.c clusterchain.h  errors.h \
 mallocv.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

sort.o: sort.c sort.h FAT_fs.h  clusterchain.h entrylist.h \
 errors.h options.h stringlist.h regexlist.h endianness.h sig.h misc.h deviceio.h \
 mallocv.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

misc.o: misc.c misc.h options.h  FAT_fs.h stringlist.h \
 mallocv.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

natstrcmp.o: natstrcmp.c natstrcmp.h mallocv.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

stringlist.o: stringlist.c stringlist.h  FAT_fs.h errors.h \
 mallocv.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

regexlist.o: regexlist.c regexlist.h  FAT_fs.h errors.h \
 mallocv.h Makefile
	$(CC) ${CFLAGS} -c $< -o $@

deviceio.o: deviceio.c deviceio.h  \
	 mallocv.h Makefile
		$(CC) ${CFLAGS} -c $< -o $@

mallocv.o: mallocv.c mallocv.h errors.h
	$(CC) ${CFLAGS} -c $< -o $@

install:
	install $(INSTALL_FLAGS) ${EXECUTABLE} $(DESTDIR)$(SBINDIR)/${EXECUTABLE}

clean:
	rm -f *.o ${EXECUTABLE}

.PHONY: all clean

=== docker_tests/docker_tests_amd64/Makefile ===
DOCKER=$(shell which podman)
TOUCH=$(shell which touch)
WGET=$(shell which wget)
TAR=$(shell which tar)

all: build_image
	$(DOCKER) run --rm --privileged -v ${CURDIR}:/home/tester/artifacts --tmpfs /tmp:rw,noexec,nosuid,size=2G -it fatsort-test-amd64

build_image: Dockerfile do_tests.sh
	$(DOCKER) build -t fatsort-test-amd64  .
	$(TOUCH) build_image

clean:
	rm -f *.log
	rm -f build_image
	rm -f *.tar.gz

.PHONY: clean build

=== docker_tests/docker_tests_arm/Makefile ===
DOCKER=$(shell which podman)
TOUCH=$(shell which touch)
WGET=$(shell which wget)
TAR=$(shell which tar)

all: build_image
	$(DOCKER) run --rm --privileged -v ${CURDIR}:/home/tester/artifacts --tmpfs /tmp:rw,noexec,nosuid,size=2G -v ${CURDIR}/qemu-arm-static:/usr/bin/qemu-arm-static -it fatsort-test-arm

build_image: Dockerfile qemu-arm-static /proc/sys/fs/binfmt_misc/qemu-arm do_tests.sh
	$(DOCKER) build -t fatsort-test-arm -v ${CURDIR}/qemu-arm-static:/usr/bin/qemu-arm-static .
	$(TOUCH) build_image

qemu-arm-static:
	$(WGET) https://github.com/multiarch/qemu-user-static/releases/download/v4.1.0-1/qemu-arm-static.tar.gz
	$(TAR) xvfz qemu-arm-static.tar.gz

/proc/sys/fs/binfmt_misc/qemu-arm:
	$(DOCKER) run --rm --privileged multiarch/qemu-user-static:register

clean:
	rm -f *.log
	rm -f build_image
	rm -f *.tar.gz
	rm -f qemu-*-static

.PHONY: clean

=== docker_tests/docker_tests_ppc/Makefile ===
DOCKER=$(shell which podman)
TOUCH=$(shell which touch)
WGET=$(shell which wget)
TAR=$(shell which tar)

all: build_image
	$(DOCKER) run --rm --privileged -v ${CURDIR}:/home/tester/artifacts --tmpfs /tmp:rw,noexec,nosuid,size=2G -v ${CURDIR}/qemu-ppc-static:/usr/bin/qemu-ppc-static -it fatsort-test-ppc

build_image: Dockerfile qemu-ppc-static
	$(DOCKER) build -t fatsort-test-ppc -v ${CURDIR}/qemu-ppc-static:/usr/bin/qemu-ppc-static  .
	$(TOUCH) build_image

qemu-ppc-static:
	$(WGET) https://github.com/multiarch/qemu-user-static/releases/download/v4.1.0-1/qemu-ppc-static.tar.gz
	$(TAR) xvfz qemu-ppc-static.tar.gz

/proc/sys/fs/binfmt_misc/ppc:
	$(DOCKER) run --rm --privileged multiarch/qemu-user-static:register

clean:
	rm -f *.log
	rm -f build_image
	rm -f *.tar.gz
	rm -f qemu-*-static

.PHONY: clean

=== tests/tc_neg_bad_dir_entry_checksum/Makefile ===
include ../testconfig.mk

TESTLOG=test.log

STDOUT=stdout.log
STDOUT_EXP=stdout_expected.txt
STDERR=stderr.log
STDERR_EXP=stderr_expected.txt
REF_FS_XZ=${IMAGEDIR}/fat32_bad_dir_entry_checksum.img.xz

XZ=xz

all: passed
	if [ ${DEL_FS_ON_PASS} -eq 1 ]; then rm -f ${FS_IMG}; fi

clean:
	rm -f passed
	rm -fr *.log *.tmp ${FS_IMG} ${TMPFILE} ${TMPDIR}

$(FS_IMG): $(REF_FS_XZ)
	# ++++++++++ Unpacking reference file systen ++++++++++
	mkdir -p $(TMPDIR)
	${XZ} -d -f --stdout ${REF_FS_XZ} >> ${FS_IMG}

execute: $(FS_IMG)
	# ++++++++++ Executing tests ++++++++++
	${FATSORT} ${FS_IMG} > ${STDOUT} 2> ${STDERR}; [ $$? -ne 0 ]
	diff ${STDOUT} ${STDOUT_EXP}
	diff ${STDERR} ${STDERR_EXP}

# check result
fsck: execute
	# ++++++++++ Checking file system ++++++++++
	fsck.vfat -n ${FS_IMG}

# test passed
passed: execute
	touch passed

.PHONY: passed fsck execute clean

=== tests/tc_neg_bad_fat_size_fat12/Makefile ===
include ../testconfig.mk

TESTLOG=test.log

STDOUT=stdout.log
STDOUT_EXP=stdout_expected.txt
STDERR=stderr.log
STDERR_EXP=stderr_expected.txt
REF_FS_XZ=${IMAGEDIR}/fat12_bad_fat_size.img.xz

XZ=xz

all: passed
	if [ ${DEL_FS_ON_PASS} -eq 1 ]; then rm -f ${FS_IMG}; fi

clean:
	rm -f passed
	rm -fr *.log *.tmp ${FS_IMG} ${TMPFILE} ${TMPDIR}

$(FS_IMG): $(REF_FS_XZ)
	# ++++++++++ Unpacking reference file systen ++++++++++
	mkdir -p $(TMPDIR)
	${XZ} -d -f --stdout ${REF_FS_XZ} >> ${FS_IMG}

execute: $(FS_IMG)
	# ++++++++++ Executing tests ++++++++++
	${FATSORT} ${FS_IMG} > ${STDOUT} 2> ${STDERR}; [ $$? -ne 0 ]
	diff ${STDOUT} ${STDOUT_EXP}
	diff ${STDERR} ${STDERR_EXP}

# check result
fsck: execute
	# ++++++++++ Checking file system ++++++++++
	fsck.vfat -n ${FS_IMG}

# test passed
passed: execute
	touch passed

.PHONY: passed fsck execute clean

=== tests/tc_neg_bad_fat_size_fat32/Makefile ===
include ../testconfig.mk

TESTLOG=test.log

STDOUT=stdout.log
STDOUT_EXP=stdout_expected.txt
STDERR=stderr.log
STDERR_EXP=stderr_expected.txt
REF_FS_XZ=${IMAGEDIR}/fat32_bad_fat_size.img.xz

XZ=xz

all: passed
	if [ ${DEL_FS_ON_PASS} -eq 1 ]; then rm -f ${FS_IMG}; fi

clean:
	rm -f passed
	rm -fr *.log *.tmp ${FS_IMG} ${TMPFILE} ${TMPDIR}

$(FS_IMG): $(REF_FS_XZ)
	# ++++++++++ Unpacking reference file systen ++++++++++
	mkdir -p $(TMPDIR)
	${XZ} -d -f --stdout ${REF_FS_XZ} >> ${FS_IMG}

execute: $(FS_IMG)
	# ++++++++++ Executing tests ++++++++++
	${FATSORT} ${FS_IMG} > ${STDOUT} 2> ${STDERR}; [ $$? -ne 0 ]
	diff ${STDOUT} ${STDOUT_EXP}
	diff ${STDERR} ${STDERR_EXP}

# check result
fsck: execute
	# ++++++++++ Checking file system ++++++++++
	fsck.vfat -n ${FS_IMG}

# test passed
passed: execute
	touch passed

.PHONY: passed fsck execute clean

=== tests/tc_neg_bad_total_sector_size_fat32/Makefile ===
include ../testconfig.mk

TESTLOG=test.log

STDOUT=stdout.log
STDOUT_EXP=stdout_expected.txt
STDERR=stderr.log
STDERR_EXP=stderr_expected.txt
REF_FS_XZ=${IMAGEDIR}/fat32_bad_total_sector_size.img.xz

XZ=xz

all: passed
	if [ ${DEL_FS_ON_PASS} -eq 1 ]; then rm -f ${FS_IMG}; fi

clean:
	rm -f passed
	rm -fr *.log *.tmp ${FS_IMG} ${TMPFILE} ${TMPDIR}

$(FS_IMG): $(REF_FS_XZ)
	# ++++++++++ Unpacking reference file systen ++++++++++
	mkdir -p $(TMPDIR)
	${XZ} -d -f --stdout ${REF_FS_XZ} >> ${FS_IMG}

execute: $(FS_IMG)
	# ++++++++++ Executing tests ++++++++++
	${FATSORT} ${FS_IMG} > ${STDOUT} 2> ${STDERR}; [ $$? -ne 0 ]
	diff ${STDOUT} ${STDOUT_EXP}
	diff ${STDERR} ${STDERR_EXP}

# check result
fsck: execute
	# ++++++++++ Checking file system ++++++++++
	fsck.vfat -n ${FS_IMG}

# test passed
passed: execute
	touch passed

.PHONY: passed fsck execute clean

=== tests/tc_neg_dirty_volume_exfat/Makefile ===
include ../testconfig.mk

TESTLOG=test.log

STDOUT=stdout.log
STDOUT_EXP=stdout_expected.txt
STDERR=stderr.log
STDERR_EXP=stderr_expected.txt
REF_FS_XZ=${IMAGEDIR}/exfat_dirty_volume.img.xz

XZ=xz

all: passed
	if [ ${DEL_FS_ON_PASS} -eq 1 ]; then rm -f ${FS_IMG}; fi

clean:
	rm -f passed
	rm -fr *.log *.tmp ${FS_IMG} ${TMPFILE} ${TMPDIR}

$(FS_IMG): $(REF_FS_XZ)
	# ++++++++++ Unpacking reference file systen ++++++++++
	mkdir -p $(TMPDIR)
	${XZ} -d -f --stdout ${REF_FS_XZ} >> ${FS_IMG}

execute: $(FS_IMG)
	# ++++++++++ Executing tests ++++++++++
	${FATSORT} ${FS_IMG} > ${STDOUT} 2> ${STDERR}; [ $$? -ne 0 ]
	diff ${STDOUT} ${STDOUT_EXP}
	diff ${STDERR} ${STDERR_EXP}

# check result
fsck: execute
	# ++++++++++ Checking file system ++++++++++
	fsck.vfat -n ${FS_IMG}

# test passed
passed: execute
	touch passed

.PHONY: passed fsck execute clean

=== tests/tc_neg_faulty_ord_in_lne_in_root_dir_fat16/Makefile ===
include ../testconfig.mk

TESTLOG=test.log

STDOUT=stdout.log
STDOUT_EXP=stdout_expected.txt
STDERR=stderr.log
STDERR_EXP=stderr_expected.txt
REF_FS_XZ=${IMAGEDIR}/fat16_faulty_ord_in_lne_in_root_dir.img.xz

XZ=xz

all: passed
	if [ ${DEL_FS_ON_PASS} -eq 1 ]; then rm -f ${FS_IMG}; fi

clean:
	rm -f passed
	rm -fr *.log *.tmp ${FS_IMG} ${TMPFILE} ${TMPDIR}

$(FS_IMG): $(REF_FS_XZ)
	# ++++++++++ Unpacking reference file systen ++++++++++
	mkdir -p $(TMPDIR)
	${XZ} -d -f --stdout ${REF_FS_XZ} >> ${FS_IMG}

execute: $(FS_IMG)
	# ++++++++++ Executing tests ++++++++++
	${FATSORT} ${FS_IMG} > ${STDOUT} 2> ${STDERR}; [ $$? -ne 0 ]
	diff ${STDOUT} ${STDOUT_EXP}
	diff ${STDERR} ${STDERR_EXP}

# check result
fsck: execute
	# ++++++++++ Checking file system ++++++++++
	fsck.vfat -n ${FS_IMG}

# test passed
passed: execute
	touch passed

.PHONY: passed fsck execute clean

=== tests/tc_neg_missing_last_lne_in_root_dir_fat32/Makefile ===
include ../testconfig.mk

TESTLOG=test.log

STDOUT=stdout.log
STDOUT_EXP=stdout_expected.txt
STDERR=stderr.log
STDERR_EXP=stderr_expected.txt
REF_FS_XZ=${IMAGEDIR}/fat32_missing_last_lne_in_root_dir.img.xz

XZ=xz

all: passed
	if [ ${DEL_FS_ON_PASS} -eq 1 ]; then rm -f ${FS_IMG}; fi

clean:
	rm -f passed
	rm -fr *.log *.tmp ${FS_IMG} ${TMPFILE} ${TMPDIR}

$(FS_IMG): $(REF_FS_XZ)
	# ++++++++++ Unpacking reference file systen ++++++++++
	mkdir -p $(TMPDIR)
	${XZ} -d -f --stdout ${REF_FS_XZ} >> ${FS_IMG}

execute: $(FS_IMG)
	# ++++++++++ Executing tests ++++++++++
	${FATSORT} ${FS_IMG} > ${STDOUT} 2> ${STDERR}; [ $$? -ne 0 ]
	diff ${STDOUT} ${STDOUT_EXP}
	diff ${STDERR} ${STDERR_EXP}

# check result
fsck: execute
	# ++++++++++ Checking file system ++++++++++
	fsck.vfat -n ${FS_IMG}

# test passed
passed: execute
	touch passed

.PHONY: passed fsck execute clean

=== debian/changelog ===
fatsort (1.6.4.625-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release (Closes: #994792, #915436).
  * Update copyright years.
  * Declare compliance with Debian Policy 4.6.2.0.
  * Enable FORTIFY_SOURCE via CPPFLAGS.

 -- Alex Muntada <alexm@debian.org>  Mon, 27 Feb 2023 23:57:01 +0100

=== debian/control ===
Source: fatsort
Section: utils
Priority: optional
Maintainer: Jordi Sayol <g.sayol@gmail.com>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
               help2man
Standards-Version: 4.6.2.0
Vcs-Git: https://salsa.debian.org/debian/fatsort.git
Vcs-Browser: https://salsa.debian.org/debian/fatsort
Homepage: http://fatsort.sourceforge.net

Package: fatsort
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: utility for sorting FAT directory structures
 FATSort is a utility that sorts FAT16 and FAT32 partitions. It even
 can handle long file name entries. It reads the boot sector and sorts
 the directory structure recursively.
 This is for example useful for sorting the files on your MP3 player when
 it doesn't implement a sorting function itself.

## fatsort 1.6.5.640

=== src/Makefile ===
--- 
+++ 
@@ -9,7 +9,7 @@
 endif
 
 CFLAGS += -Wall -Wextra
-override CFLAGS+= -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE64_SOURCE
+override CFLAGS+= -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE64_SOURCE ${CPPFLAGS}
 
 INSTALL_FLAGS=-m 0755 -p -D

=== tests/Makefile ===
SHELL=/bin/bash
DATE=/bin/date

.PHONY: clean

LOGFILE="results.log"

TESTSUITES=$(wildcard ts_*)

all: ts_amd64

check_prerequisites:
#	@which valgrind &>/dev/null || (echo "You need valgrind to run the tests!"; false)

$(TESTSUITES): check_prerequisites 
	@SECONDS=0; failed=0; tests=0; new=0; \
	echo "Tests of testsuite $@ started on $(shell $(DATE) '+%Y-%m-%d %H:%M:%S')" | tee ${LOGFILE}; \
	for i in `cat $@`; do \
		if [ ! -f $$i/passed ]; then \
			printf "%.70s" "Test case $$i...                                                                 "; \
			printf "[ \e[1;33mWAIT \e[0m]"; \
			${MAKE} -C $$i &> /dev/null; \
			ret=$$?; \
			printf "\r%.70s" "Test case $$i...                                                                 "; \
			if [ $$ret -eq 0 ]; then \
				printf "[ \e[1;32mPASS \e[0m]\n"; \
				echo "Test case $$i passed." >> $(LOGFILE); \
			else \
				printf "[ \e[1;31mFAIL \e[0m]\n"; \
				echo "Test case $$i failed." >> $(LOGFILE); \
				(( failed+=1 )); \
			fi; \
			(( new+=1 )); \
		fi; \
		(( tests+=1 )); \
	done; \
	ELAPSED="$$((($$SECONDS / 60) % 60))' $$(($$SECONDS % 60))\""; \
	if [ $$failed -eq 0 ]; then \
	echo "All" $$tests "tests passed ("$$new "in this round) in $$ELAPSED." | tee -a ${LOGFILE}; \
	else \
	echo $$failed"/"$$tests "tests failed! ("$$new "in this round) in $$ELAPSED." | tee -a ${LOGFILE}; \
	fi; \
	[ "$$failed" -eq "0" ]

clean:
	rm -f *.log
	rm -f tc_*/*.log tc*/passed
	rm -f images/*.img
#	for i in `ls -d tc_*`; do $(MAKE) -C $$i clean || [ 1 ]; done


.PHONY: check_prerequisites clean

=== docker_tests/docker_tests_amd64/Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 TAR=$(shell which tar)
 
 all: build_image
-	$(DOCKER) run --rm --privileged -v ${CURDIR}:/home/tester/artifacts --tmpfs /tmp:rw,noexec,nosuid,size=2G -it fatsort-test-amd64
+	$(DOCKER) run --rm --privileged --group-add keep-groups -v ${CURDIR}:/home/tester/artifacts --tmpfs /tmp:rw,noexec,nosuid,size=2G -it fatsort-test-amd64
 
 build_image: Dockerfile do_tests.sh
 	$(DOCKER) build -t fatsort-test-amd64  .

=== docker_tests/docker_tests_ppc/Makefile ===
DOCKER=$(shell which podman)
TOUCH=$(shell which touch)
WGET=$(shell which wget)
TAR=$(shell which tar)

all: build_image
	$(DOCKER) run --rm --privileged --group-add keep-groups -v ${CURDIR}:/home/tester/artifacts --tmpfs /tmp:rw,noexec,nosuid,size=2G -v ${CURDIR}/qemu-ppc-static:/usr/bin/qemu-ppc-static -it fatsort-test-ppc

build_image: Dockerfile qemu-ppc-static
	$(DOCKER) build -t fatsort-test-ppc -v ${CURDIR}/qemu-ppc-static:/usr/bin/qemu-ppc-static  .
	$(TOUCH) build_image

qemu-ppc-static:
	$(WGET) https://github.com/multiarch/qemu-user-static/releases/download/v4.1.0-1/qemu-ppc-static.tar.gz
	$(TAR) xvfz qemu-ppc-static.tar.gz

/proc/sys/fs/binfmt_misc/ppc:
	$(DOCKER) run --rm --privileged --group-add keep-groups multiarch/qemu-user-static:register

clean:
	rm -f *.log
	rm -f build_image
	rm -f *.tar.gz
	rm -f qemu-*-static

.PHONY: clean

=== docker_tests/docker_tests_ppc64le/Makefile ===
DOCKER=$(shell which podman)
TOUCH=$(shell which touch)
WGET=$(shell which wget)
TAR=$(shell which tar)

all: build_image
	$(DOCKER) run --rm --privileged -v ${CURDIR}:/home/tester/artifacts --tmpfs /tmp:rw,noexec,nosuid,size=2G -v ${CURDIR}/qemu-ppc64le-static:/usr/bin/qemu-ppc64le-static -it fatsort-test-ppc64le

build_image: Dockerfile qemu-ppc64le-static /proc/sys/fs/binfmt_misc/qemu-ppc64le do_tests.sh
	$(DOCKER) build -t fatsort-test-ppc64le -v ${CURDIR}/qemu-ppc64le-static:/usr/bin/qemu-ppc64le-static  .
	$(TOUCH) build_image

qemu-ppc64le-static:
	$(WGET) https://github.com/multiarch/qemu-user-static/releases/download/v4.1.0-1/qemu-ppc64le-static.tar.gz
	$(TAR) xvfz qemu-ppc64le-static.tar.gz

/proc/sys/fs/binfmt_misc/qemu-ppc64le:
	$(DOCKER) run --rm --privileged multiarch/qemu-user-static:register

clean:
	rm -f *.log
	rm -f build_image
	rm -f *.tar.gz
	rm -f qemu-*-static

.PHONY: clean

=== docker_tests/docker_tests_s390x/Makefile ===
DOCKER=$(shell which podman)
TOUCH=$(shell which touch)
WGET=$(shell which wget)
TAR=$(shell which tar)

all: build_image
	$(DOCKER) run --rm --privileged --group-add keep-groups -v ${CURDIR}:/home/tester/artifacts --tmpfs /tmp:rw,noexec,nosuid,size=2G -v ${CURDIR}/qemu-s390x-static:/usr/bin/qemu-s390x-static -it fatsort-test-s390x

build_image: Dockerfile qemu-s390x-static do_tests.sh
	$(DOCKER) build -t fatsort-test-s390x -v ${CURDIR}/qemu-s390x-static:/usr/bin/qemu-s390x-static  .
	$(TOUCH) build_image

qemu-s390x-static:
	$(WGET) https://github.com/multiarch/qemu-user-static/releases/download/v4.1.0-1/qemu-s390x-static.tar.gz
	$(TAR) xvfz qemu-s390x-static.tar.gz

/proc/sys/fs/binfmt_misc/s390x:
	$(DOCKER) run --rm --privileged --group-add keep-groups multiarch/qemu-user-static:register

clean:
	rm -f *.log
	rm -f build_image
	rm -f *.tar.gz
	rm -f qemu-*-static

.PHONY: clean

=== tests/tc_check_consistent_version/Makefile ===
include ../testconfig.mk

all: passed 

execute:
	manver=\
	`head -2 ../../man/fatsort.1 | tail -1 | sed -e "s/^.*\"fatsort \([0-9\.]\+\)\".*/\1/"`; \
	progver=`../../src/fatsort --version | head -1 | sed -e "s/^fatsort \([0-9.]\+\).*/\1/"`; \
	changesver=`head -3 ../../CHANGES.md | tail -1 | sed -e "s/^.*v\([0-9.]\+\).*/\1/"`; \
	echo "#$$manver#$$progver#$$changesver#"; \
	[ "$$manver" = "$$progver" ]; \
	[ "$$changesver" = "$$progver" ]

passed: execute
	touch passed

clean:
	rm -f passed

.PHONY: clean execute

=== tests/tc_neg_bad_fat_size_fat16/Makefile ===
include ../testconfig.mk

TESTLOG=test.log

STDOUT=stdout.log
STDOUT_EXP=stdout_expected.txt
STDERR=stderr.log
STDERR_EXP=stderr_expected.txt
REF_FS_XZ=${IMAGEDIR}/fat16_bad_fat_size.img.xz

XZ=xz

all: passed
	if [ ${DEL_FS_ON_PASS} -eq 1 ]; then rm -f ${FS_IMG}; fi

clean:
	rm -f passed
	rm -fr *.log *.tmp ${FS_IMG} ${TMPFILE} ${TMPDIR}

$(FS_IMG): $(REF_FS_XZ)
	# ++++++++++ Unpacking reference file systen ++++++++++
	mkdir -p $(TMPDIR)
	${XZ} -d -f --stdout ${REF_FS_XZ} >> ${FS_IMG}

execute: $(FS_IMG)
	# ++++++++++ Executing tests ++++++++++
	${FATSORT} ${FS_IMG} > ${STDOUT} 2> ${STDERR}; [ $$? -ne 0 ]
	diff ${STDOUT} ${STDOUT_EXP}
	diff ${STDERR} ${STDERR_EXP}

# check result
fsck: execute
	# ++++++++++ Checking file system ++++++++++
	fsck.vfat -n ${FS_IMG}

# test passed
passed: execute
	touch passed

.PHONY: passed fsck execute clean

=== tests/tc_neg_bad_number_of_fats/Makefile ===
include ../testconfig.mk

TESTLOG=test.log

STDOUT=stdout.log
STDOUT_EXP=stdout_expected.txt
STDERR=stderr.log
STDERR_EXP=stderr_expected.txt
REF_FS_XZ=${IMAGEDIR}/fat32_bad_number_of_fats.img.xz

XZ=xz

all: passed
	if [ ${DEL_FS_ON_PASS} -eq 1 ]; then rm -f ${FS_IMG}; fi

clean:
	rm -f passed
	rm -fr *.log *.tmp ${FS_IMG} ${TMPFILE} ${TMPDIR}

$(FS_IMG): $(REF_FS_XZ)
	# ++++++++++ Unpacking reference file systen ++++++++++
	mkdir -p $(TMPDIR)
	${XZ} -d -f --stdout ${REF_FS_XZ} >> ${FS_IMG}

execute: $(FS_IMG)
	# ++++++++++ Executing tests ++++++++++
	${FATSORT} ${FS_IMG} > ${STDOUT} 2> ${STDERR}; [ $$? -ne 0 ]
	diff ${STDOUT} ${STDOUT_EXP}
	diff ${STDERR} ${STDERR_EXP}

# check result
fsck: execute
	# ++++++++++ Checking file system ++++++++++
	fsck.vfat -n ${FS_IMG}

# test passed
passed: execute
	touch passed

.PHONY: passed fsck execute clean

=== tests/tc_neg_bad_reserved_sector_count/Makefile ===
include ../testconfig.mk

TESTLOG=test.log

STDOUT=stdout.log
STDOUT_EXP=stdout_expected.txt
STDERR=stderr.log
STDERR_EXP=stderr_expected.txt
REF_FS_XZ=${IMAGEDIR}/fat32_bad_reserved_sector_count.img.xz

XZ=xz

all: passed
	if [ ${DEL_FS_ON_PASS} -eq 1 ]; then rm -f ${FS_IMG}; fi

clean:
	rm -f passed
	rm -fr *.log *.tmp ${FS_IMG} ${TMPFILE} ${TMPDIR}

$(FS_IMG): $(REF_FS_XZ)
	# ++++++++++ Unpacking reference file systen ++++++++++
	mkdir -p $(TMPDIR)
	${XZ} -d -f --stdout ${REF_FS_XZ} >> ${FS_IMG}

execute: $(FS_IMG)
	# ++++++++++ Executing tests ++++++++++
	${FATSORT} ${FS_IMG} > ${STDOUT} 2> ${STDERR}; [ $$? -ne 0 ]
	diff ${STDOUT} ${STDOUT_EXP}
	diff ${STDERR} ${STDERR_EXP}

# check result
fsck: execute
	# ++++++++++ Checking file system ++++++++++
	fsck.vfat -n ${FS_IMG}

# test passed
passed: execute
	touch passed

.PHONY: passed fsck execute clean

=== tests/tc_neg_broken_cluster_chain/Makefile ===
include ../testconfig.mk

TESTLOG=test.log

STDOUT=stdout.log
STDOUT_EXP=stdout_expected.txt
STDERR=stderr.log
STDERR_EXP=stderr_expected.txt
REF_FS_XZ=${IMAGEDIR}/fat32_broken_cluster_chain.img.xz

XZ=xz

all: passed
	if [ ${DEL_FS_ON_PASS} -eq 1 ]; then rm -f ${FS_IMG}; fi

clean:
	rm -f passed
	rm -fr *.log *.tmp ${FS_IMG} ${TMPFILE} ${TMPDIR}

$(FS_IMG): $(REF_FS_XZ)
	# ++++++++++ Unpacking reference file systen ++++++++++
	mkdir -p $(TMPDIR)
	${XZ} -d -f --stdout ${REF_FS_XZ} >> ${FS_IMG}

execute: $(FS_IMG)
	# ++++++++++ Executing tests ++++++++++
	${FATSORT} ${FS_IMG} > ${STDOUT} 2> ${STDERR}; [ $$? -ne 0 ]
	diff ${STDOUT} ${STDOUT_EXP}
	diff ${STDERR} ${STDERR_EXP}

# check result
fsck: execute
	# ++++++++++ Checking file system ++++++++++
	fsck.vfat -n ${FS_IMG}

# test passed
passed: execute
	touch passed

.PHONY: passed fsck execute clean

=== tests/tc_neg_cluster_size_too_big/Makefile ===
include ../testconfig.mk

TESTLOG=test.log

STDOUT=stdout.log
STDOUT_EXP=stdout_expected.txt
STDERR=stderr.log
STDERR_EXP=stderr_expected.txt
REF_FS_XZ=${IMAGEDIR}/fat32_cluster_size_too_big.img.xz

XZ=xz

all: passed
	if [ ${DEL_FS_ON_PASS} -eq 1 ]; then rm -f ${FS_IMG}; fi

clean:
	rm -f passed
	rm -fr *.log *.tmp ${FS_IMG} ${TMPFILE} ${TMPDIR}

$(FS_IMG): $(REF_FS_XZ)
	# ++++++++++ Unpacking reference file systen ++++++++++
	mkdir -p $(TMPDIR)
	${XZ} -d -f --stdout ${REF_FS_XZ} >> ${FS_IMG}

execute: $(FS_IMG)
	# ++++++++++ Executing tests ++++++++++
	${FATSORT} ${FS_IMG} > ${STDOUT} 2> ${STDERR}; [ $$? -ne 0 ]
	diff ${STDOUT} ${STDOUT_EXP}
	diff ${STDERR} ${STDERR_EXP}

# check result
fsck: execute
	# ++++++++++ Checking file system ++++++++++
	fsck.vfat -n ${FS_IMG}

# test passed
passed: execute
	touch passed

.PHONY: passed fsck execute clean

=== debian/changelog ===
fatsort (1.6.5.640-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Use secure URI in Homepage field.

  [ Alex Muntada ]
  * Take over maintenance (Closes: #1032432).
  * New upstream release.
  * Remove d/patches, already applied upstream.
  * Update copyright years.

 -- Alex Muntada <alexm@debian.org>  Sun, 07 Apr 2024 12:32:50 +0200

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,14 @@
 Source: fatsort
 Section: utils
 Priority: optional
-Maintainer: Jordi Sayol <g.sayol@gmail.com>
+Maintainer: Alex Muntada <alexm@debian.org>
 Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13),
                help2man
 Standards-Version: 4.6.2.0
 Vcs-Git: https://salsa.debian.org/debian/fatsort.git
 Vcs-Browser: https://salsa.debian.org/debian/fatsort
-Homepage: http://fatsort.sourceforge.net
+Homepage: https://fatsort.sourceforge.net
 
 Package: fatsort
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_install:
	# 'man' target is not explicitly called in Makefile but it is
	# needed here since debclean removes man/fatsort.1
	make man
	dh_auto_install -- SBINDIR=/usr/bin MANDIR=/usr/share/man/man1

=== debian/watch ===
version=4
  https://sf.net/fatsort/ fatsort-(.+)\.tar\.xz debian uupdate
